--Lx-Office ERP Datenbankschema

--Eindeutige ID
CREATE SEQUENCE "id" start 1 increment 1 maxvalue 9223372036854775807 minvalue 1 cache 1;
CREATE SEQUENCE "glid" start 1 increment 1 maxvalue 9223372036854775807 minvalue 1 cache 1;

--Lx-Office ERP Basistabellen
CREATE TABLE "gl" (
	"id" integer DEFAULT nextval('glid'::text),
	"reference" text,
	"description" text,
	"transdate" date DEFAULT date('now'::text),
	"gldate" date DEFAULT date ('now'::text),
	"employee_id" integer,
	"notes" text,
	"department_id" integer DEFAULT 0,
	"taxincluded" boolean
);


CREATE TABLE "chart" (
	"id" integer DEFAULT nextval('id'::text),
	"accno" text NOT NULL,
	"description" text,
	"charttype" character(1) DEFAULT 'A',
	"category" character(1),
	"link" text,
	"gifi_accno" text,
        "taxkey_id" integer,
        "pos_ustva" integer,
        "pos_bwa" integer,
        "pos_bilanz" integer,
        "pos_eur" integer
);


CREATE TABLE "gifi" (
	"accno" text,
	"description" text
);


CREATE TABLE "defaults" (
	"inventory_accno_id" integer,
	"income_accno_id" integer,
	"expense_accno_id" integer,
	"fxgain_accno_id" integer,
	"fxloss_accno_id" integer,
	"invnumber" text,
	"sonumber" text,
	"yearend" character varying(5),
	"weightunit" character varying(5),
	"businessnumber" text,
	"version" character varying(8),
	"curr" text,
	"closedto" date,
	"revtrans" boolean DEFAULT 'f',
	"ponumber" text,
	"sqnumber" text,
	"rfqnumber" text
);
INSERT INTO defaults (version) VALUES ('1.0.0');

CREATE TABLE "acc_trans" (
	"trans_id" integer,
	"chart_id" integer,
	"amount" double precision,
	"transdate" date DEFAULT date('now'::text),
	"gldate" date DEFAULT date ('now'::text),
	"source" text,
	"cleared" boolean DEFAULT 'f',
	"fx_transaction" boolean DEFAULT 'f',
	"project_id" integer,
	"memo" text,
        "taxkey" integer
);


CREATE TABLE "invoice" (
	"id" integer DEFAULT nextval('invoiceid'::text),
	"trans_id" integer,
	"parts_id" integer,
	"description" text,
	"qty" real,
	"allocated" real,
	"sellprice" double precision,
	"fxsellprice" double precision,
	"discount" real,
	"assemblyitem" boolean DEFAULT 'f',
	"unit" character varying(5),
	"project_id" integer,
	"deliverydate" date,
	"serialnumber" text
);

CREATE TABLE "vendor" (
	"id" integer DEFAULT nextval('id'::text),
	"name" character varying(75),
	"street" character varying(75),
	"zipcode" character varying(10),
	"city" character varying(75),
	"country" character varying(75),
	"contact" character varying(75),
	"phone" character varying(30),
	"fax" character varying(30),
	"homepage" text,
	"email" text,
	"notes" text,
	"terms" smallint DEFAULT 0,
	"taxincluded" boolean,
	"vendornumber" text,
	"cc" text,
	"bcc" text,
	"gifi_accno" text,
	"business_id" integer,
	"taxnumber" text,
	"sic_code" text,
	"discount" real,
	"creditlimit" double precision
);

CREATE TABLE "customer" (
	"id" integer DEFAULT nextval('id'::text),
	"name" character varying(75),
	"street" character varying(75),
	"zipcode" character varying(10),
	"city" character varying(75),
	"country" character varying(75),
	"contact" character varying(75),
	"phone" character varying(30),
	"fax" character varying(30),
	"homepage" text,
	"email" text,
	"notes" text,
	"discount" real,
	"taxincluded" boolean,
	"creditlimit" double precision DEFAULT 0,
	"terms" smallint DEFAULT 0,
	"customernumber" text,
	"cc" text,
	"bcc" text,
	"business_id" integer,
	"taxnumber" text,
	"sic_code" text
);

CREATE TABLE "contacts" (
	"cp_id" integer DEFAULT nextval('id'::text),
	"cp_cv_id" integer,
	"cp_greeting" character varying(75),
	"cp_title" character varying(75),
	"cp_givenname" character varying(75),
	"cp_name" character varying(75),
	"cp_email" text,
	"cp_phone1" character varying(75),
	"cp_phone2" character varying(75)
);

CREATE TABLE "parts" (
	"id" integer DEFAULT nextval('id'::text),
	"partnumber" text,
	"description" text,
	"unit" character varying(5),
	"listprice" double precision,
	"sellprice" double precision,
	"lastcost" double precision,
	"priceupdate" date DEFAULT date('now'::text),
	"weight" real,
	"onhand" real DEFAULT 0,
	"notes" text,
	"makemodel" boolean DEFAULT 'f',
	"assembly" boolean DEFAULT 'f',
	"alternate" boolean DEFAULT 'f',
	"rop" real,
	"inventory_accno_id" integer,
	"income_accno_id" integer,
	"expense_accno_id" integer,
	"bin" text,
	"shop" boolean DEFAULT 'f',
	"obsolete" boolean DEFAULT 'f',
	"bom" boolean DEFAULT 'f',
	"image" text,
	"drawing" text,
	"microfiche" text,
	"partsgroup_id" integer
);

CREATE TABLE "assembly" (
	"id" integer,
	"parts_id" integer,
	"qty" double precision,
	"bom" boolean
);

CREATE TABLE "ar" (
	"id" integer DEFAULT nextval('glid'::text),
	"invnumber" text,
	"transdate" date DEFAULT date('now'::text),
	"gldate" date DEFAULT date ('now'::text),
	"customer_id" integer,
	"taxincluded" boolean,
	"amount" double precision,
	"netamount" double precision,
	"paid" double precision,
	"datepaid" date,
	"duedate" date,
	"invoice" boolean DEFAULT 'f',
	"shippingpoint" text,
	"terms" smallint DEFAULT 0,
	"notes" text,
	"curr" character(3),
	"ordnumber" text,
	"employee_id" integer,
	"quonumber" text,
	"intnotes" text,
	"department_id" integer DEFAULT 0,
	"shipvia" text
);

CREATE TABLE "ap" (
	"id" integer DEFAULT nextval('glid'::text),
	"invnumber" text,
	"transdate" date DEFAULT date('now'::text),
	"gldate" date DEFAULT date ('now'::text),
	"vendor_id" integer,
	"taxincluded" boolean DEFAULT 'f',
	"amount" double precision,
	"netamount" double precision,
	"paid" double precision,
	"datepaid" date,
	"duedate" date,
	"invoice" boolean DEFAULT 'f',
	"ordnumber" text,
	"curr" character(3),
	"notes" text,
	"employee_id" integer,
	"quonumber" text,
	"intnotes" text,
	"department_id" integer DEFAULT 0,
	"shipvia" text
);

CREATE TABLE "partstax" (
	"parts_id" integer,
	"chart_id" integer
);

CREATE TABLE "tax" (
	"chart_id" integer,
	"rate" double precision,
	"taxnumber" text,
        "taxkey" integer,
        "taxdescription" text
);

CREATE TABLE "customertax" (
	"customer_id" integer,
	"chart_id" integer
);

CREATE TABLE "vendortax" (
	"vendor_id" integer,
	"chart_id" integer
);

CREATE TABLE "oe" (
	"id" integer DEFAULT nextval('id'::text),
	"ordnumber" text,
	"transdate" date DEFAULT date('now'::text),
	"vendor_id" integer,
	"customer_id" integer,
	"amount" double precision,
	"netamount" double precision,
	"reqdate" date,
	"taxincluded" boolean,
	"shippingpoint" text,
	"notes" text,
	"curr" character(3),
	"employee_id" integer,
	"closed" boolean DEFAULT 'f',
	"quotation" boolean DEFAULT 'f',
	"quonumber" text,
	"intnotes" text,
	"department_id" integer DEFAULT 0,
	"shipvia" text
);

CREATE TABLE "orderitems" (
	"trans_id" integer,
	"parts_id" integer,
	"description" text,
	"qty" real,
	"sellprice" double precision,
	"discount" real,
	"unit" character varying(5),
	"project_id" integer,
	"reqdate" date,
	"ship" real,
	"serialnumber" text,
	"id" integer DEFAULT nextval('orderitemsid'::text)
);

CREATE TABLE "exchangerate" (
	"curr" character(3),
	"transdate" date,
	"buy" double precision,
	"sell" double precision
);

CREATE TABLE "employee" (
	"id" integer DEFAULT nextval('id'::text),
	"login" text,
	"name" character varying(35),
	"addr1" character varying(35),
	"addr2" character varying(35),
	"addr3" character varying(35),
	"addr4" character varying(35),
	"workphone" character varying(20),
	"homephone" character varying(20),
	"startdate" date DEFAULT date('now'::text),
	"enddate" date,
	"notes" text,
	"role" text,
	"sales" boolean DEFAULT 't'
);

CREATE TABLE "shipto" (
	"trans_id" integer,
	"shiptoname" character varying(75),
	"shiptostreet" character varying(75),
	"shiptozipcode" character varying(75),
	"shiptocity" character varying(75),
	"shiptocountry" character varying(75),
	"shiptocontact" character varying(75),
	"shiptophone" character varying(30),
	"shiptofax" character varying(30),
	"shiptoemail" text
);

CREATE TABLE "project" (
	"id" integer DEFAULT nextval('id'::text),
	"projectnumber" text,
	"description" text
);

CREATE TABLE "partsgroup" (
	"id" integer DEFAULT nextval('id'::text),
	"partsgroup" text
);

CREATE TABLE "makemodel" (
	"parts_id" integer,
	"make" text,
	"model" text
);

CREATE TABLE "status" (
	"trans_id" integer,
	"formname" text,
	"printed" boolean DEFAULT 'f',
	"emailed" boolean DEFAULT 'f',
	"spoolfile" text,
	"chart_id" integer
);

CREATE SEQUENCE "invoiceid" start 1 increment 1 maxvalue 9223372036854775807 minvalue 1 cache 1;

CREATE SEQUENCE "orderitemsid" start 1 increment 1 maxvalue 100000 minvalue 1 cache 1 cycle;

CREATE TABLE "warehouse" (
	"id" integer DEFAULT nextval('id'::text),
	"description" text
);

CREATE TABLE "inventory" (
	"warehouse_id" integer,
	"parts_id" integer,
	"oe_id" integer,
	"orderitems_id" integer,
	"qty" real,
	"shippingdate" date,
	"employee_id" integer
);

CREATE TABLE "department" (
	"id" integer DEFAULT nextval('id'::text),
	"description" text,
	"role" character(1) DEFAULT 'P'
);

CREATE TABLE "dpt_trans" (
	"trans_id" integer,
	"department_id" integer
);

CREATE TABLE "business" (
	"id" integer DEFAULT nextval('id'::text),
	"description" text,
	"discount" real
);

CREATE TABLE "sic" (
	"code" text,
	"sictype" character(1),
	"description" text
);

CREATE FUNCTION "check_department" () RETURNS opaque AS '
declare
  dpt_id int;
begin
  if new.department_id = 0 then
    delete from dpt_trans where trans_id = new.id;
    return NULL;
  end if;
  select into dpt_id trans_id from dpt_trans where trans_id = new.id;
  if dpt_id > 0 then
    update dpt_trans set department_id = new.department_id where trans_id = dpt_id;
  else
    insert into dpt_trans (trans_id, department_id) values (new.id, new.department_id);
  end if;
return NULL;
end;
' LANGUAGE 'plpgsql';
-- end function

CREATE FUNCTION "del_department" () RETURNS opaque AS '
begin
  delete from dpt_trans where trans_id = old.id;
  return NULL;
end;
' LANGUAGE 'plpgsql';
-- end function

CREATE FUNCTION "del_customer" () RETURNS opaque AS '
begin
  delete from shipto where trans_id = old.id;
  delete from customertax where customer_id = old.id;
  return NULL;
end;
' LANGUAGE 'plpgsql';
-- end function

CREATE FUNCTION "del_vendor" () RETURNS opaque AS '
begin
  delete from shipto where trans_id = old.id;
  delete from vendortax where vendor_id = old.id;
  return NULL;
end;
' LANGUAGE 'plpgsql';
-- end function

CREATE FUNCTION "del_exchangerate" () RETURNS opaque AS '
declare
  t_transdate date;
  t_curr char(3);
  t_id int;
  d_curr text;
begin
  select into d_curr substr(curr,1,3) from defaults;
  if TG_RELNAME = ''ar'' then
    select into t_curr, t_transdate curr, transdate from ar where id = old.id;
  end if;
  if TG_RELNAME = ''ap'' then
    select into t_curr, t_transdate curr, transdate from ap where id = old.id;
  end if;
  if TG_RELNAME = ''oe'' then
    select into t_curr, t_transdate curr, transdate from oe where id = old.id;
  end if;
  if d_curr != t_curr then
    select into t_id a.id from acc_trans ac
    join ar a on (a.id = ac.trans_id)
    where a.curr = t_curr
    and ac.transdate = t_transdate
    except select a.id from ar a where a.id = old.id
    union
    select a.id from acc_trans ac
    join ap a on (a.id = ac.trans_id)
    where a.curr = t_curr
    and ac.transdate = t_transdate
    except select a.id from ap a where a.id = old.id
    union
    select o.id from oe o
    where o.curr = t_curr
    and o.transdate = t_transdate
    except select o.id from oe o where o.id = old.id;
    if not found then
      delete from exchangerate where curr = t_curr and transdate = t_transdate;
    end if;
  end if;
return old;
end;
' LANGUAGE 'plpgsql';
-- end function

CREATE FUNCTION "check_inventory" () RETURNS opaque AS '
declare
  itemid int;
  row_data inventory%rowtype;
begin
  if not old.quotation then
    for row_data in select * from inventory where oe_id = old.id loop
      select into itemid id from orderitems where trans_id = old.id and id = row_data.orderitems_id;
      if itemid is null then
	delete from inventory where oe_id = old.id and orderitems_id = row_data.orderitems_id;
      end if;
    end loop;
  end if;
  return old;
end;
' LANGUAGE 'plpgsql';
-- end function

CREATE INDEX acc_trans_trans_id_key ON acc_trans USING btree (trans_id);

CREATE INDEX acc_trans_chart_id_key ON acc_trans USING btree (chart_id);

CREATE INDEX acc_trans_transdate_key ON acc_trans USING btree (transdate);

CREATE INDEX acc_trans_source_key ON acc_trans USING btree (lower(source));

CREATE INDEX ap_id_key ON ap USING btree (id);

CREATE INDEX ap_transdate_key ON ap USING btree (transdate);

CREATE INDEX ap_invnumber_key ON ap USING btree (lower(invnumber));

CREATE INDEX ap_ordnumber_key ON ap USING btree (lower(ordnumber));

CREATE INDEX ap_vendor_id_key ON ap USING btree (vendor_id);

CREATE INDEX ap_employee_id_key ON ap USING btree (employee_id);

CREATE INDEX ar_id_key ON ar USING btree (id);

CREATE INDEX ar_transdate_key ON ar USING btree (transdate);

CREATE INDEX ar_invnumber_key ON ar USING btree (lower(invnumber));

CREATE INDEX ar_ordnumber_key ON ar USING btree (lower(ordnumber));

CREATE INDEX ar_customer_id_key ON ar USING btree (customer_id);

CREATE INDEX ar_employee_id_key ON ar USING btree (employee_id);

CREATE INDEX assembly_id_key ON assembly USING btree (id);

CREATE INDEX chart_id_key ON chart USING btree (id);

CREATE UNIQUE INDEX chart_accno_key ON chart USING btree (accno);

CREATE INDEX chart_category_key ON chart USING btree (category);

CREATE INDEX chart_link_key ON chart USING btree (link);

CREATE INDEX chart_gifi_accno_key ON chart USING btree (gifi_accno);

CREATE INDEX customer_id_key ON customer USING btree (id);

CREATE INDEX customer_customer_id_key ON customertax USING btree (customer_id);

CREATE INDEX customer_customernumber_key ON customer USING btree (customernumber);

CREATE INDEX customer_name_key ON customer USING btree (name);

CREATE INDEX customer_contact_key ON customer USING btree (contact);

CREATE INDEX employee_id_key ON employee USING btree (id);

CREATE UNIQUE INDEX employee_login_key ON employee USING btree (login);

CREATE INDEX employee_name_key ON employee USING btree (name);

CREATE INDEX exchangerate_ct_key ON exchangerate USING btree (curr, transdate);

CREATE UNIQUE INDEX gifi_accno_key ON gifi USING btree (accno);

CREATE INDEX gl_id_key ON gl USING btree (id);

CREATE INDEX gl_transdate_key ON gl USING btree (transdate);

CREATE INDEX gl_reference_key ON gl USING btree (lower(reference));

CREATE INDEX gl_description_key ON gl USING btree (lower(description));

CREATE INDEX gl_employee_id_key ON gl USING btree (employee_id);

CREATE INDEX invoice_id_key ON invoice USING btree (id);

CREATE INDEX invoice_trans_id_key ON invoice USING btree (trans_id);

CREATE INDEX oe_id_key ON oe USING btree (id);

CREATE INDEX oe_transdate_key ON oe USING btree (transdate);

CREATE INDEX oe_ordnumber_key ON oe USING btree (lower(ordnumber));

CREATE INDEX oe_employee_id_key ON oe USING btree (employee_id);

CREATE INDEX orderitems_trans_id_key ON orderitems USING btree (trans_id);

CREATE INDEX parts_id_key ON parts USING btree (id);

--
-- TOC Entry ID 82 (OID 319577)
--
-- Name: "parts_partnumber_key" Type: INDEX Owner: postgres
--

CREATE INDEX parts_partnumber_key ON parts USING btree (lower(partnumber));

CREATE INDEX parts_description_key ON parts USING btree (lower(description));

CREATE INDEX partstax_parts_id_key ON partstax USING btree (parts_id);

CREATE INDEX vendor_id_key ON vendor USING btree (id);

CREATE INDEX vendor_name_key ON vendor USING btree (name);

CREATE INDEX vendor_vendornumber_key ON vendor USING btree (vendornumber);

CREATE INDEX vendor_contact_key ON vendor USING btree (contact);

CREATE INDEX vendortax_vendor_id_key ON vendortax USING btree (vendor_id);

CREATE INDEX shipto_trans_id_key ON shipto USING btree (trans_id);

CREATE INDEX project_id_key ON project USING btree (id);

CREATE INDEX ar_quonumber_key ON ar USING btree (lower(quonumber));

CREATE INDEX ap_quonumber_key ON ap USING btree (lower(quonumber));

CREATE INDEX makemodel_parts_id_key ON makemodel USING btree (parts_id);

CREATE INDEX makemodel_make_key ON makemodel USING btree (lower(make));

CREATE INDEX makemodel_model_key ON makemodel USING btree (lower(model));

CREATE INDEX status_trans_id_key ON status USING btree (trans_id);

CREATE INDEX department_id_key ON department USING btree (id);

CREATE INDEX orderitems_id_key ON orderitems USING btree (id);




CREATE TRIGGER "check_department" AFTER INSERT OR UPDATE ON "ar"  FOR EACH ROW EXECUTE PROCEDURE "check_department" ();
-- end trigger

CREATE TRIGGER "check_department" AFTER INSERT OR UPDATE ON "ap"  FOR EACH ROW EXECUTE PROCEDURE "check_department" ();
-- end trigger


CREATE TRIGGER "check_department" AFTER INSERT OR UPDATE ON "gl"  FOR EACH ROW EXECUTE PROCEDURE "check_department" ();
-- end trigger


CREATE TRIGGER "check_department" AFTER INSERT OR UPDATE ON "oe"  FOR EACH ROW EXECUTE PROCEDURE "check_department" ();
-- end trigger


CREATE TRIGGER "del_department" AFTER DELETE ON "ar"  FOR EACH ROW EXECUTE PROCEDURE "del_department" ();
-- end trigger


CREATE TRIGGER "del_department" AFTER DELETE ON "ap"  FOR EACH ROW EXECUTE PROCEDURE "del_department" ();
-- end trigger


CREATE TRIGGER "del_department" AFTER DELETE ON "gl"  FOR EACH ROW EXECUTE PROCEDURE "del_department" ();
-- end trigger


CREATE TRIGGER "del_department" AFTER DELETE ON "oe"  FOR EACH ROW EXECUTE PROCEDURE "del_department" ();
-- end trigger


CREATE TRIGGER "del_customer" AFTER DELETE ON "customer"  FOR EACH ROW EXECUTE PROCEDURE "del_customer" ();
-- end trigger


CREATE TRIGGER "del_vendor" AFTER DELETE ON "vendor"  FOR EACH ROW EXECUTE PROCEDURE "del_vendor" ();
-- end trigger


CREATE TRIGGER "del_exchangerate" BEFORE DELETE ON "ar"  FOR EACH ROW EXECUTE PROCEDURE "del_exchangerate" ();
-- end trigger


CREATE TRIGGER "del_exchangerate" BEFORE DELETE ON "ap"  FOR EACH ROW EXECUTE PROCEDURE "del_exchangerate" ();
-- end trigger


CREATE TRIGGER "del_exchangerate" BEFORE DELETE ON "oe"  FOR EACH ROW EXECUTE PROCEDURE "del_exchangerate" ();
-- end trigger


CREATE TRIGGER "check_inventory" AFTER UPDATE ON "oe"  FOR EACH ROW EXECUTE PROCEDURE "check_inventory" ();
-- end trigger
